{  Die Function GetCPU ermittelt den arbeitenden CPU-Typ. Der
   zurckgelieferte Code entspricht: (Eine weiter gute Routine
   kann bei der MIB unter dem Namen CPUID.ARJ requestet werden) 
   0 - Intel 8088     1 - Intel 8086
   2 - NEC V20        3 - NEC V30
   4 - Intel 80188    5 - Intel 80186
   6 - Intel 80286    7 - Intel 80386
   8 - Intel 80486    9 - Intel Pentium }

FUNCTION GetCpu: BYTE; ASSEMBLER;
CONST Processor: Byte= $FF;      { Ergebnis fuer spaeter merken }
ASM
mov  al, processor
cmp  al, 0FFh                    { haben wir schon mal getestet? }
jne  @get_out                    { ja, also nicht schon wieder... }
				 { TEST 80(1)86/(1)88/NEC VS. 80286+ }       
pushf       
xor  bx,bx
push bx
popf
pushf
pop  bx
and  bx,0F000h
cmp  bx,0F000h
je   @no286    { TEST 80286 VS. 80386+ }
mov  bx,07000h
push bx
popf
pushf
pop  bx
and  bx,07000h
jne  @test486
mov  dl,6
jmp  @end
                                { TEST 80386 VS. 80486+ }
@test486:
mov  dl,7
xor  si,si
mov  ax,cs    {$IFDEF DPMI}
add  ax,SelectorInc           { use alias segment selector }    
{$ENDIF}
mov  es,ax
mov  byte ptr es:[@queue486+11], 46h     { 46h == "INC SI" }
@queue486: nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop; nop
or   si,si
jnz  @end    { TEST 80486 VS. PENTIUM }
inc  dl
db   66h ; pushf      { pushfd }
db   66h ; pushf      { pushfd }
db   66h ; pop  ax    { pop eax }
db   66h ; mov  cx,ax { mov ecx,eax }
db   66h,35h
db   00h,00h,20h,00h  { xor eax,(1 shl 21) (Pentium ID flag) }
db   66h ; push ax    { push eax }
db   66h ; popf       { popfd }
db   66h ; pushf      { pushfd }
db   66h ; pop  ax    { pop eax }
db   66h,25h
db   00h,00h,20h,00h  { and eax,(1 shl 21) }
db   66h,81h,0E1h
db   00h,00h,20h,00h  { and ecx,(1 shl 21) }
db   66h ; cmp ax,cx  { cmp eax,ecx }
je   @is486
inc  dl
@is486: db   66h; 
popf                  { popfd }
jmp  @end
@no286:
    { TEST IF 80188/186 }
mov  dl,5
mov  al,0FFh
mov  cl,21h
shr  al,cl
jnz  @testdatabus    { TEST 8088/86 VS. NEC V20/30 }
mov  dl,2
sti
xor  si,si
mov  cx,0FFFFh
    {$IFDEF DPMI}      { muss eigtl. gar nicht sein, }
push es                { XTs koennen eh kein DPMI ;-) }
push ds
pop  es                { Notloesung; kann schiefgehn... }    {$ENDIF}
rep  seges lodsb      { == rep lods byte ptr es:[si] }    {$IFDEF DPMI}
pop  es    {$ENDIF}
or   cx,cx
jz   @testdatabus
mov  dl,1            { argh. intel 8088/86 inside... }    @testdatabus:
    { TEST 8 BIT DATA BUS (80(1)88/NEC V30) VS. 16 BIT (80(1)86/V20) }
push cs    {$IFDEF DPMI}
pop  ax
add  ax,SelectorInc           { use alias segment selector }
mov  es,ax    {$ELSE}
pop  es    {$ENDIF}
xor  bx,bx
std
mov  al,90h
mov  cx,3
call @ip2di
cli
rep  stosb
cld
nop; nop; nop
inc  bx
nop
sti
or   bx,bx
jz   @end      { v20 or 8086 or 80186 }
cmp  dl,1
je   @its8088
cmp  dl,2
je   @itsV30
cmp  dl,5
jne  @end
dec  dl
jmp  @end
@its8088:
dec  dl
jmp  @end
@itsV30:
inc  dl
jmp  @end
@ip2di:
pop  di
push di
add  di,9
retn
@end:
popf
mov  al,dl
mov  processor,al
@get_out:
End;

Begin
 Writeln(GetCPU);
 readln;
end.
